
#ifndef PLS_ROOT_WORKER_TASK_H
#define PLS_ROOT_WORKER_TASK_H

#include "root_master_task.h"

namespace pls {
    namespace internal {
        namespace scheduling {
            template<typename Function>
            class root_worker_task : public abstract_task {
                root_master_task<Function>* master_task_;

            public:
                explicit root_worker_task(root_master_task<Function>* master_task):
                    abstract_task{0, 0},
                    master_task_{master_task} {}

                void execute() override {
                    do {
                        steal_work();
                    } while (!master_task_->finished());
                }

                bool my_stealing(abstract_task* /*other_task*/) override {
                    return false;
                }
            };
        }
    }
}

#endif //PLS_ROOT_WORKER_TASK_H
